services:
  - docker:17.07.0-dind

stages:
  - Build
  - Dockerize

Build:
  stage: Build
  image: rust:latest
  script:
    - cargo build --release --verbose
    - cargo test --verbose -- --test-threads=1
  artifacts:
    paths:
    - target/release/rustyproxy-srv
    expire_in: 20 minutes
  cache:
    paths:
      - target

Dockerize:
  stage: Dockerize
  image: docker:17.07.0
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:dev-$CI_COMMIT_SHORT_SHA .
    - docker push $CI_REGISTRY_IMAGE:dev-$CI_COMMIT_SHORT_SHA
  only:
    refs:
      - main
  dependencies:
    - Build


